Package com.sas.metadata.remote

# Interface Event

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Event extends PrimaryType
Describes a condition that occurs that drives other actions, ie. jobs, to be processed.

Attributes of Event are:

- `Condition`
- `EventRole`

Associations of Event are:

- `EventBrokers`
- `TriggeredTransforms`
- `TriggeringTransforms`

## Usage

To create an instance of this Event, use the `factory` create methods.
Example: create a Event with name "Event_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Event myObject = (Event) factory.createComplexMetadataObject(objectStore, "Event_Object", MetadataObjects.EVENT, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_EVENTBROKERS_NAME`
  Constant used for the name of the EventBrokers association.
  `static final String`
  `ASSOCIATION_TRIGGEREDTRANSFORMS_NAME`
  Constant used for the name of the TriggeredTransforms association.
  `static final String`
  `ASSOCIATION_TRIGGERINGTRANSFORMS_NAME`
  Constant used for the name of the TriggeringTransforms association.
  `static final String`
  `ATTRIBUTE_CONDITION_NAME`
  Constant used for the name of the Condition attribute.
  `static final String`
  `ATTRIBUTE_EVENTROLE_NAME`
  Constant used for the name of the EventRole attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getCondition()`
  Gets the `String` value of `Condition`
  `int`
  `getConditionMaxLength()`
  Gets the maximum length of `Condition`
  `int`
  `getConditionState()`
  Gets the Metadata State of `Condition`
  `AssociationList`
  `getEventBrokers()`
  Gets the AssociationList of `EventBrokers`
  `AssociationList`
  `getEventBrokers(boolean fGoToServer)`
  Gets the Associationlist of `EventBrokers`
  `String`
  `getEventRole()`
  Gets the `String` value of `EventRole`
  `int`
  `getEventRoleMaxLength()`
  Gets the maximum length of `EventRole`
  `int`
  `getEventRoleState()`
  Gets the Metadata State of `EventRole`
  `AssociationList`
  `getTriggeredTransforms()`
  Gets the AssociationList of `TriggeredTransforms`
  `AssociationList`
  `getTriggeredTransforms(boolean fGoToServer)`
  Gets the Associationlist of `TriggeredTransforms`
  `AssociationList`
  `getTriggeringTransforms()`
  Gets the AssociationList of `TriggeringTransforms`
  `AssociationList`
  `getTriggeringTransforms(boolean fGoToServer)`
  Gets the Associationlist of `TriggeringTransforms`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `EventBrokers`
  `TriggeredTransforms`
  `TriggeringTransforms`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setCondition(String inCondition)`
  Sets the `Condition` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCondition(String inCondition, int state)`
  Sets the `Condition` Metadata State.
  `void`
  `setConditionState(int state)`
  Sets the Metadata State of `Condition`.
  `void`
  `setEventBrokers(AssociationList list)`
  Sets the `EventBrokers` list to be `list`.
  `void`
  `setEventBrokers(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setEventRole(String inEventRole)`
  Sets the `EventRole` value and sets the state to MetadataState.LOCAL.
  `void`
  `setEventRole(String inEventRole, int state)`
  Sets the `EventRole` Metadata State.
  `void`
  `setEventRoleState(int state)`
  Sets the Metadata State of `EventRole`.
  `void`
  `setTriggeredTransforms(AssociationList list)`
  Sets the `TriggeredTransforms` list to be `list`.
  `void`
  `setTriggeredTransforms(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setTriggeringTransforms(AssociationList list)`
  Sets the `TriggeringTransforms` list to be `list`.
  `void`
  `setTriggeringTransforms(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_CONDITION_NAME

    static final String ATTRIBUTE_CONDITION_NAME
    Constant used for the name of the Condition attribute.

    Condition: Indicates what condition the triggering transformation must meet to be considered (success, failure, warnings, etc.)

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_EVENTROLE_NAME

    static final String ATTRIBUTE_EVENTROLE_NAME
    Constant used for the name of the EventRole attribute.

    EventRole: Internal or External

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_EVENTBROKERS_NAME

    static final String ASSOCIATION_EVENTBROKERS_NAME
    Constant used for the name of the EventBrokers association.

    EventBrokers: The event brokers for this set of events.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_TRIGGEREDTRANSFORMS_NAME

    static final String ASSOCIATION_TRIGGEREDTRANSFORMS_NAME
    Constant used for the name of the TriggeredTransforms association.

    TriggeredTransforms: The transforms that are triggered by this event.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_TRIGGERINGTRANSFORMS_NAME

    static final String ASSOCIATION_TRIGGERINGTRANSFORMS_NAME
    Constant used for the name of the TriggeringTransforms association.

    TriggeringTransforms: The transforms that trigger these events.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `EventBrokers`
    `TriggeredTransforms`
    `TriggeringTransforms`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCondition

    String getCondition() throws RemoteException
    Gets the `String` value of `Condition`
    Returns:
      The `Condition`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getConditionState

    int getConditionState() throws RemoteException
    Gets the Metadata State of `Condition`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getConditionMaxLength

    int getConditionMaxLength() throws RemoteException
    Gets the maximum length of `Condition`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEventRole

    String getEventRole() throws RemoteException
    Gets the `String` value of `EventRole`
    Returns:
      The `EventRole`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEventRoleState

    int getEventRoleState() throws RemoteException
    Gets the Metadata State of `EventRole`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEventRoleMaxLength

    int getEventRoleMaxLength() throws RemoteException
    Gets the maximum length of `EventRole`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEventBrokers

    AssociationList getEventBrokers() throws RemoteException, MdException
    Gets the AssociationList of `EventBrokers`
    Returns:
      Returns the AssociationList of `EventBrokers` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTriggeredTransforms

    AssociationList getTriggeredTransforms() throws RemoteException, MdException
    Gets the AssociationList of `TriggeredTransforms`
    Returns:
      Returns the AssociationList of `TriggeredTransforms` which can be of type:
      AbstractTransformation
      TransformationStep
      SyncStep
      TransformationActivity
      FeatureMap
      ColumnHierarchy
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTriggeringTransforms

    AssociationList getTriggeringTransforms() throws RemoteException, MdException
    Gets the AssociationList of `TriggeringTransforms`
    Returns:
      Returns the AssociationList of `TriggeringTransforms` which can be of type:
      AbstractTransformation
      TransformationStep
      SyncStep
      TransformationActivity
      FeatureMap
      ColumnHierarchy
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getEventBrokers

    AssociationList getEventBrokers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `EventBrokers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `EventBrokers` which can be of type:
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTriggeredTransforms

    AssociationList getTriggeredTransforms(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `TriggeredTransforms`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `TriggeredTransforms` which can be of type:
      AbstractTransformation
      TransformationStep
      SyncStep
      TransformationActivity
      FeatureMap
      ColumnHierarchy
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTriggeringTransforms

    AssociationList getTriggeringTransforms(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `TriggeringTransforms`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `TriggeringTransforms` which can be of type:
      AbstractTransformation
      TransformationStep
      SyncStep
      TransformationActivity
      FeatureMap
      ColumnHierarchy
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setCondition

    void setCondition(String inCondition) throws RemoteException
    Sets the `Condition` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCondition` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCondition

    void setCondition(String inCondition, int state) throws RemoteException
    Sets the `Condition` Metadata State.
    Parameters:
      `inCondition` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setConditionState

    void setConditionState(int state) throws RemoteException
    Sets the Metadata State of `Condition`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEventRole

    void setEventRole(String inEventRole) throws RemoteException
    Sets the `EventRole` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inEventRole` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEventRole

    void setEventRole(String inEventRole, int state) throws RemoteException
    Sets the `EventRole` Metadata State.
    Parameters:
      `inEventRole` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEventRoleState

    void setEventRoleState(int state) throws RemoteException
    Sets the Metadata State of `EventRole`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEventBrokers

    void setEventBrokers(AssociationList list) throws RemoteException
    Sets the `EventBrokers` list to be `list`. Objects of which can be of type:
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEventBrokers

    void setEventBrokers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTriggeredTransforms

    void setTriggeredTransforms(AssociationList list) throws RemoteException
    Sets the `TriggeredTransforms` list to be `list`. Objects of which can be of type:
    AbstractTransformation
    TransformationStep
    SyncStep
    TransformationActivity
    FeatureMap
    ColumnHierarchy
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTriggeredTransforms

    void setTriggeredTransforms(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTriggeringTransforms

    void setTriggeringTransforms(AssociationList list) throws RemoteException
    Sets the `TriggeringTransforms` list to be `list`. Objects of which can be of type:
    AbstractTransformation
    TransformationStep
    SyncStep
    TransformationActivity
    FeatureMap
    ColumnHierarchy
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTriggeringTransforms

    void setTriggeringTransforms(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.